diff -urN /home/henrik/hobbit/release/hobbit-4.2.0/client/logfetch.c ./client/logfetch.c
--- /home/henrik/hobbit/release/hobbit-4.2.0/client/logfetch.c	2006-08-09 22:09:58.000000000 +0200
+++ ./client/logfetch.c	2006-10-03 13:52:28.000000000 +0200
@@ -52,8 +52,10 @@
 	long lastpos[POSCOUNT];
 	long maxbytes;
 #endif
-	char *trigger;
-	char *ignore;
+	char **trigger;
+	int triggercount;
+	char **ignore;
+	int ignorecount;
 } logdef_t;
 
 typedef struct filedef_t {
@@ -111,7 +113,7 @@
 	int openerr, i, status, triggerlinecount, done;
 	char *linepos[2*LINES_AROUND_TRIGGER+1];
 	int lpidx;
-	regex_t ignexpr, trigexpr;
+	regex_t *ignexpr = NULL, *trigexpr = NULL;
 #ifdef _LARGEFILE_SOURCE
 	off_t bufsz;
 #else
@@ -188,13 +190,21 @@
 	}
 
 	/* Compile the regex patterns */
-	if (logdef->ignore) {
-		status = regcomp(&ignexpr, logdef->ignore, REG_EXTENDED|REG_ICASE|REG_NOSUB);
-		if (status != 0) logdef->ignore = NULL;
-	}
-	if (logdef->trigger) {
-		status = regcomp(&trigexpr, logdef->trigger, REG_EXTENDED|REG_ICASE|REG_NOSUB);
-		if (status != 0) logdef->trigger = NULL;
+	if (logdef->ignorecount) {
+		int i;
+		ignexpr = (regex_t *) malloc(logdef->ignorecount * sizeof(regex_t));
+		for (i=0; (i < logdef->ignorecount); i++) {
+			status = regcomp(&ignexpr[i], logdef->ignore[i], REG_EXTENDED|REG_ICASE|REG_NOSUB);
+			if (status != 0) logdef->ignore[i] = NULL;
+		}
+	}
+	if (logdef->triggercount) {
+		int i;
+		trigexpr = (regex_t *) malloc(logdef->triggercount * sizeof(regex_t));
+		for (i=0; (i < logdef->triggercount); i++) {
+			status = regcomp(&trigexpr[i], logdef->trigger[i], REG_EXTENDED|REG_ICASE|REG_NOSUB);
+			if (status != 0) logdef->trigger[i] = NULL;
+		}
 	}
 	triggerstartpos = triggerendpos = NULL;
 	triggerlinecount = 0;
@@ -222,17 +232,27 @@
 		}
 
 		/* Check ignore pattern */
-		if (logdef->ignore) {
-			status = regexec(&ignexpr, fillpos, 0, NULL, 0);
-			if (status == 0) continue;
+		if (logdef->ignorecount) {
+			int i, match = 0;
+
+			for (i=0; ((i < logdef->ignorecount) && !match); i++) {
+				match = (regexec(&ignexpr[i], fillpos, 0, NULL, 0) == 0);
+			}
+
+			if (match) continue;
 		}
 
 		linepos[lpidx] = fillpos;
 
 		/* See if this is a trigger line */
-		if (logdef->trigger) {
-			status = regexec(&trigexpr, fillpos, 0, NULL, 0);
-			if (status == 0) {
+		if (logdef->triggercount) {
+			int i, match = 0;
+
+			for (i=0; ((i < logdef->ignorecount) && !match); i++) {
+				match = (regexec(&trigexpr[i], fillpos, 0, NULL, 0) == 0);
+			}
+
+			if (match) {
 				int sidx;
 				
 				sidx = lpidx - LINES_AROUND_TRIGGER; 
@@ -270,6 +290,7 @@
 	if (bytesread > logdef->maxbytes) {
 		char *skiptxt = "<...SKIPPED...>\n";
 
+		/* FIXME: Must make sure to only pass complete lines back to the server */
 		if (triggerstartpos) {
 			/* Skip the beginning of the data up until the trigger was found */
 			startpos = triggerstartpos;
@@ -322,8 +343,24 @@
 
 cleanup:
 	if (fd) fclose(fd);
-	if (logdef->ignore) regfree(&ignexpr);
-	if (logdef->trigger) regfree(&trigexpr);
+
+	{
+		int i;
+
+		if (logdef->ignorecount) {
+			for (i=0; (i < logdef->ignorecount); i++) {
+				if (logdef->ignore[i]) regfree(&ignexpr[i]);
+			}
+			xfree(ignexpr);
+		}
+
+		if (logdef->triggercount) {
+			for (i=0; (i < logdef->triggercount); i++) {
+				if (logdef->trigger[i]) regfree(&trigexpr[i]);
+			}
+			xfree(trigexpr);
+		}
+	}
 
 	return startpos;
 }
@@ -707,12 +744,33 @@
 					checkdef_t *walk = currcfg;
 
 					do {
-						walk->check.logcheck.ignore = strdup(p);
+						walk->check.logcheck.ignorecount++;
+						if (walk->check.logcheck.ignore == NULL) {
+							walk->check.logcheck.ignore = (char **)malloc(sizeof(char *));
+						}
+						else {
+							walk->check.logcheck.ignore = 
+								(char **)realloc(walk->check.logcheck.ignore, 
+										 walk->check.logcheck.ignorecount * sizeof(char **));
+						}
+
+						walk->check.logcheck.ignore[walk->check.logcheck.ignorecount-1] = strdup(p);
+
 						walk = walk->next;
 					} while (walk && (walk != firstpipeitem->next));
 				}
 				else {
-					currcfg->check.logcheck.ignore = strdup(p);
+					currcfg->check.logcheck.ignorecount++;
+					if (currcfg->check.logcheck.ignore == NULL) {
+						currcfg->check.logcheck.ignore = (char **)malloc(sizeof(char *));
+					}
+					else {
+						currcfg->check.logcheck.ignore = 
+							(char **)realloc(currcfg->check.logcheck.ignore, 
+									 currcfg->check.logcheck.ignorecount * sizeof(char **));
+					}
+
+					currcfg->check.logcheck.ignore[currcfg->check.logcheck.ignorecount-1] = strdup(p);
 				}
 			}
 			else if (strncmp(bol, "trigger ", 8) == 0) {
@@ -725,12 +783,33 @@
 					checkdef_t *walk = currcfg;
 
 					do {
-						walk->check.logcheck.trigger = strdup(p);
+						walk->check.logcheck.triggercount++;
+						if (walk->check.logcheck.trigger == NULL) {
+							walk->check.logcheck.trigger = (char **)malloc(sizeof(char *));
+						}
+						else {
+							walk->check.logcheck.trigger = 
+								(char **)realloc(walk->check.logcheck.trigger, 
+										 walk->check.logcheck.triggercount * sizeof(char **));
+						}
+
+						walk->check.logcheck.trigger[walk->check.logcheck.triggercount-1] = strdup(p);
+
 						walk = walk->next;
 					} while (walk && (walk != firstpipeitem->next));
 				}
 				else {
-					currcfg->check.logcheck.trigger = strdup(p);
+					currcfg->check.logcheck.triggercount++;
+					if (currcfg->check.logcheck.trigger == NULL) {
+						currcfg->check.logcheck.trigger = (char **)malloc(sizeof(char *));
+					}
+					else {
+						currcfg->check.logcheck.trigger = 
+							(char **)realloc(currcfg->check.logcheck.trigger, 
+									 currcfg->check.logcheck.triggercount * sizeof(char **));
+					}
+
+					currcfg->check.logcheck.trigger[currcfg->check.logcheck.triggercount-1] = strdup(p);
 				}
 			}
 		}
diff -urN /home/henrik/hobbit/release/hobbit-4.2.0/client/msgcache.c ./client/msgcache.c
--- /home/henrik/hobbit/release/hobbit-4.2.0/client/msgcache.c	2006-08-09 22:09:58.000000000 +0200
+++ ./client/msgcache.c	2006-10-03 12:55:27.000000000 +0200
@@ -440,7 +440,9 @@
 			freestrbuffer(zombie->msgbuf);
 			xfree(zombie);
 		}
-		if (!chead) ctail = NULL;
+		ctail = chead;
+		if (ctail) { while (ctail->next) ctail = ctail->next; }
+
 
 		/* Remove expired messages */
 		qwalk = qhead; qprev = NULL;
diff -urN /home/henrik/hobbit/release/hobbit-4.2.0/client/runclient.sh ./client/runclient.sh
--- /home/henrik/hobbit/release/hobbit-4.2.0/client/runclient.sh	2006-08-09 22:09:58.000000000 +0200
+++ ./client/runclient.sh	2006-10-03 12:55:27.000000000 +0200
@@ -76,7 +76,7 @@
 
   	if test -s $HOBBITCLIENTHOME/logs/clientlaunch.$MACHINEDOTS.pid; then
 		echo "Hobbit client already running, re-starting it"
-		$0 stop
+		$0 --hostname="$MACHINEDOTS" stop
 		rm -f $HOBBITCLIENTHOME/logs/clientlaunch.$MACHINEDOTS.pid
 	fi
 
@@ -99,12 +99,12 @@
 
   "restart")
   	if test -s $HOBBITCLIENTHOME/logs/clientlaunch.$MACHINEDOTS.pid; then
-		$0 stop
+		$0 --hostname="$MACHINEDOTS" stop
 	else
 		echo "Hobbit client not running, continuing to start it"
 	fi
 
-	$0 start
+	$0 --hostname="$MACHINEDOTS" --os="$BBOSTYPE" start
 	;;
 
   "status")
diff -urN /home/henrik/hobbit/release/hobbit-4.2.0/configure.server ./configure.server
--- /home/henrik/hobbit/release/hobbit-4.2.0/configure.server	2006-08-09 22:10:23.000000000 +0200
+++ ./configure.server	2006-10-03 13:52:28.000000000 +0200
@@ -316,13 +316,16 @@
 echo "top-level directory. I can set this up if you tell me"
 echo "what group-ID your webserver runs with. This is typically"
 echo "'nobody' or 'apache' or 'www-data'"
-echo "If you dont know, just hit ENTER and we will handle it later."
 echo ""
-echo "What group-ID does your webserver use ?"
+echo "What group-ID does your webserver use [nobody] ?"
 if test -z "$HTTPDGID"
 then
 	read HTTPDGID
 fi
+if test -z "$HTTPDGID"
+then
+	HTTPDGID="nobody"
+fi
 echo ""; echo ""
 
 echo "Where to put the Hobbit logfiles [/var/log/hobbit] ? "
diff -urN /home/henrik/hobbit/release/hobbit-4.2.0/hobbitd/Makefile ./hobbitd/Makefile
--- /home/henrik/hobbit/release/hobbit-4.2.0/hobbitd/Makefile	2006-08-09 22:10:05.000000000 +0200
+++ ./hobbitd/Makefile	2006-10-03 13:52:28.000000000 +0200
@@ -1,4 +1,4 @@
-PROGRAMS = hobbit.sh hobbitd hobbitd_channel hobbitd_filestore hobbitd_history hobbitd_alert hobbitd_rrd hobbitd_sample hobbitd_client hobbitd_hostdata hobbitd_capture hobbitfetch hobbit-mailack trimhistory bbcombotest hobbitreports.sh moverrd.sh
+PROGRAMS = hobbit.sh hobbitd hobbitd_channel hobbitd_filestore hobbitd_history hobbitd_alert hobbitd_rrd hobbitd_sample hobbitd_client hobbitd_hostdata hobbitd_capture hobbitfetch hobbit-mailack trimhistory bbcombotest hobbitreports.sh moverrd.sh convertnk
 CLIENTPROGRAMS = ../client/hobbitd_client
 
 LIBOBJS = ../lib/libbbgen.a
@@ -17,7 +17,7 @@
 MAILACKOBJS   = hobbit-mailack.o
 TRIMHISTOBJS  = trimhistory.o
 FETCHOBJS     = hobbitfetch.o
-
+CONVERTNKOBJS = convertnk.o
 
 IDTOOL := $(shell if test `uname -s` = "SunOS"; then echo /usr/xpg4/bin/id; else echo id; fi)
 
@@ -91,6 +91,9 @@
 hobbitfetch: $(FETCHOBJS) $(LIBOBJS)
 	$(CC) $(CFLAGS) -o $@ $(RPATHOPT) $(FETCHOBJS) $(LIBOBJS) $(NETLIBS)
 
+convertnk: $(CONVERTNKOBJS) $(LIBOBJS)
+	$(CC) $(CFLAGS) -o $@ $(RPATHOPT) $(CONVERTNKOBJS) $(LIBOBJS) $(NETLIBS)
+
 hobbit.sh: hobbit.sh.DIST
 	cat $< | sed -e 's!@BBHOME@!$(BBHOME)!g' | sed -e 's!@BBLOGDIR@!$(BBLOGDIR)!g' | sed -e 's!@BBUSER@!$(BBUSER)!g' | sed -e 's!@RUNTIMEDEFS@!$(RUNTIMEDEFS)!g' >$@
 	chmod 755 $@
diff -urN /home/henrik/hobbit/release/hobbit-4.2.0/hobbitd/client_config.c ./hobbitd/client_config.c
--- /home/henrik/hobbit/release/hobbit-4.2.0/hobbitd/client_config.c	2006-08-09 22:10:05.000000000 +0200
+++ ./hobbitd/client_config.c	2006-10-03 12:55:27.000000000 +0200
@@ -1249,6 +1249,7 @@
 	*abswarn = 0;
 	*abspanic = 0;
 	*ignored = 0;
+	*group = NULL;
 
 	rule = getrule(hostname, pagename, classname, C_DISK);
 	while (rule && !namematch(fsname, rule->rule.disk.fsexp->pattern, rule->rule.disk.fsexp->exp)) {
diff -urN /home/henrik/hobbit/release/hobbit-4.2.0/hobbitd/convertnk.c ./hobbitd/convertnk.c
--- /home/henrik/hobbit/release/hobbit-4.2.0/hobbitd/convertnk.c	1970-01-01 01:00:00.000000000 +0100
+++ ./hobbitd/convertnk.c	2006-10-03 13:52:28.000000000 +0200
@@ -0,0 +1,54 @@
+/*----------------------------------------------------------------------------*/
+/* Hobbit utility to convert the deprecated NK tags to a hobbit-nkview.cfg    */
+/*                                                                            */
+/* Copyright (C) 2006 Henrik Storner <henrik@hswn.dk>                         */
+/*                                                                            */
+/* This program is released under the GNU General Public License (GPL),       */
+/* version 2. See the file "COPYING" for details.                             */
+/*                                                                            */
+/*----------------------------------------------------------------------------*/
+
+static char rcsid[] = "$Id: convertnk.c,v 1.1 2006/09/12 21:27:11 henrik Exp $";
+
+#include <string.h>
+#include <stdlib.h>
+#include <unistd.h>
+#include <stdio.h>
+
+#include "libbbgen.h"
+
+int main(int argc, char *argv[])
+{
+	namelist_t *walk;
+
+	load_hostnames(xgetenv("BBHOSTS"), NULL, get_fqdn());
+
+	for (walk = first_host(); (walk); walk=walk->next) {
+		char *nk, *nktime, *tok;
+
+		nk = bbh_item(walk, BBH_NK); if (!nk) continue;
+		nktime = bbh_item(walk, BBH_NKTIME);
+
+		nk = strdup(nk);
+
+		tok = strtok(nk, ",");
+		while (tok) {
+			char *hostname = bbh_item(walk, BBH_HOSTNAME);
+			char *startstr = "", *endstr = "", *ttgroup = "", *ttextra = "", *updinfo = "Migrated";
+			int priority = 2;
+
+			fprintf(stdout, "%s|%s|%s|%s|%s|%d|%s|%s|%s\n",
+				hostname, tok,
+				startstr, endstr,
+				(nktime ? nktime : ""),
+				priority, ttgroup, ttextra, updinfo);
+
+			tok = strtok(NULL, ",");
+		}
+
+		xfree(nk);
+	}
+
+	return 0;
+}
+
diff -urN /home/henrik/hobbit/release/hobbit-4.2.0/hobbitd/do_alert.c ./hobbitd/do_alert.c
--- /home/henrik/hobbit/release/hobbit-4.2.0/hobbitd/do_alert.c	2006-08-09 22:10:05.000000000 +0200
+++ ./hobbitd/do_alert.c	2006-10-03 12:55:27.000000000 +0200
@@ -168,7 +168,7 @@
 
 static char *message_text(activealerts_t *alert, recip_t *recip)
 {
-	strbuffer_t *buf = NULL;
+	static strbuffer_t *buf = NULL;
 	char *eoln, *bom, *p;
 	char info[4096];
 
diff -urN /home/henrik/hobbit/release/hobbit-4.2.0/hobbitd/hobbitd.c ./hobbitd/hobbitd.c
--- /home/henrik/hobbit/release/hobbit-4.2.0/hobbitd/hobbitd.c	2006-08-09 22:10:05.000000000 +0200
+++ ./hobbitd/hobbitd.c	2007-02-09 11:28:42.039878822 +0100
@@ -124,7 +124,7 @@
 typedef struct hobbitd_hostlist_t {
 	char *hostname;
 	char ip[IP_ADDR_STRLEN];
-	enum { H_NORMAL, H_SUMMARY, H_DIALUP } hosttype;
+	enum { H_NORMAL, H_SUMMARY } hosttype;
 	hobbitd_log_t *logs;
 	hobbitd_log_t *pinglog; /* Points to entry in logs list, but we need it often */
 	time_t clientmsgtstamp;
@@ -187,6 +187,7 @@
 hobbitd_channel_t *enadischn = NULL;	/* Receives "enable" and "disable" messages */
 hobbitd_channel_t *clientchn = NULL;	/* Receives "client" messages */
 hobbitd_channel_t *clichgchn = NULL;	/* Receives "clichg" messages */
+hobbitd_channel_t *userchn   = NULL;	/* Receives "usermsg" messages */
 
 #define NO_COLOR (COL_COUNT)
 static char *colnames[COL_COUNT+1];
@@ -431,7 +432,6 @@
 	hitem->hostname = strdup(hostname);
 	strcpy(hitem->ip, ip);
 	if (strcmp(hostname, "summary") == 0) hitem->hosttype = H_SUMMARY;
-	else if (strcmp(hostname, "dialup") == 0) hitem->hosttype = H_DIALUP;
 	else hitem->hosttype = H_NORMAL;
 	rbtInsert(rbhosts, hitem->hostname, hitem);
 
@@ -635,13 +635,14 @@
 			break;
 
 		  case C_NOTES:
+		  case C_USER:
 			n = snprintf(channel->channelbuf,  (bufsz-5),
 				"@@%s#%u|%d.%06d|%s|%s\n%s", 
 				channelmarker, channel->seq, (int) tstamp.tv_sec, (int) tstamp.tv_usec, 
 				sender, hostname, msg);
 			if (n > (bufsz-5)) {
-				errprintf("Oversize notes msg from %s for %s:%s truncated (n=%d, limit=%d)\n", 
-					sender, hostname, log->test->name, n, bufsz);
+				errprintf("Oversize notes/user msg from %s for %s truncated (n=%d, limit=%d)\n", 
+					sender, hostname, n, bufsz);
 			}
 			*(channel->channelbuf + bufsz - 5) = '\0';
 			break;
@@ -1292,6 +1293,13 @@
 	dbgprintf("<-handle_notes\n");
 }
 
+void handle_usermsg(char *msg, char *sender, char *hostname)
+{
+	dbgprintf("->handle_usermsg\n");
+	posttochannel(userchn, channelnames[C_USER], msg, sender, hostname, NULL, NULL);
+	dbgprintf("<-handle_usermsg\n");
+}
+
 void handle_enadis(int enabled, conn_t *msg, char *sender)
 {
 	char *firstline = NULL, *hosttest = NULL, *durstr = NULL, *txtstart = NULL;
@@ -2513,18 +2521,18 @@
 			handle_status(msg->buf, sender, h->hostname, t->name, NULL, log, color, NULL);
 		}
 	}
-	else if (strncmp(msg->buf, "notes", 5) == 0) {
+	else if ((strncmp(msg->buf, "notes", 5) == 0) || (strncmp(msg->buf, "usermsg", 7) == 0)) {
 		char *hostname, *bhost, *ehost, *p;
 		char savechar;
 
-		bhost = msg->buf + strlen("notes"); bhost += strspn(bhost, " \t");
+		bhost = msg->buf + strcspn(msg->buf, " \t\r\n"); bhost += strspn(bhost, " \t");
 		ehost = bhost + strcspn(bhost, " \t\r\n");
 		savechar = *ehost; *ehost = '\0';
 		hostname = strdup(bhost);
 		*ehost = savechar;
 
 		p = hostname; while ((p = strchr(p, ',')) != NULL) *p = '.';
-		if (*hostname == '\0') { errprintf("Invalid notes message from %s - blank hostname\n", sender); xfree(hostname); hostname = NULL; }
+		if (*hostname == '\0') { errprintf("Invalid notes/user message from %s - blank hostname\n", sender); xfree(hostname); hostname = NULL; }
 
 		if (hostname) {
 			char *hname, hostip[IP_ADDR_STRLEN];
@@ -2535,12 +2543,27 @@
 			if (hname == NULL) {
 				log_ghost(hostname, sender, msg->buf);
 			}
-			else if (!oksender(maintsenders, NULL, msg->addr.sin_addr, msg->buf)) {
-				/* Invalid sender */
-				errprintf("Invalid notes message - sender %s not allowed for host %s\n", sender, hostname);
-			}
 			else {
-				handle_notes(msg->buf, sender, hostname);
+				if (*msg->buf == 'n') {
+					/* "notes" message */
+					if (!oksender(maintsenders, NULL, msg->addr.sin_addr, msg->buf)) {
+						/* Invalid sender */
+						errprintf("Invalid notes message - sender %s not allowed for host %s\n", sender, hostname);
+					}
+					else {
+						handle_notes(msg->buf, sender, hostname);
+					}
+				}
+				else if (*msg->buf == 'u') {
+					/* "usermsg" message */
+					if (!oksender(statussenders, NULL, msg->addr.sin_addr, msg->buf)) {
+						/* Invalid sender */
+						errprintf("Invalid user message - sender %s not allowed for host %s\n", sender, hostname);
+					}
+					else {
+						handle_usermsg(msg->buf, sender, hostname);
+					}
+				}
 			}
 
 			xfree(hostname);
@@ -2787,7 +2810,7 @@
 				continue;
 			}
 
-			/* If there is a hostname filter, drop the "summary" and "dialup 'hosts' */
+			/* If there is a hostname filter, drop the "summary" 'hosts' */
 			if (shost && (hwalk->hosttype != H_NORMAL)) continue;
 
 			firstlog = hwalk->logs;
@@ -2953,7 +2976,7 @@
 		if (!oksender(wwwsenders, NULL, msg->addr.sin_addr, msg->buf)) goto done;
 
 		setup_filter(msg->buf, 
-			     "BBH_HOSTNAME,BBH_IP,BBH_BANKSIZE,BBH_RAW",
+			     "BBH_HOSTNAME,BBH_IP,BBH_RAW",
 			     &spage, &shost, &snet, &stest, &scolor, &acklevel, &fields,
 			     &chspage, &chshost, &chsnet, &chstest);
 
@@ -4159,6 +4182,8 @@
 	if (clientchn == NULL) { errprintf("Cannot setup client channel\n"); return 1; }
 	clichgchn  = setup_channel(C_CLICHG, CHAN_MASTER);
 	if (clichgchn == NULL) { errprintf("Cannot setup clichg channel\n"); return 1; }
+	userchn  = setup_channel(C_USER, CHAN_MASTER);
+	if (userchn == NULL) { errprintf("Cannot setup user channel\n"); return 1; }
 
 	errprintf("Setting up logfiles\n");
 	setvbuf(stdout, NULL, _IONBF, 0);
diff -urN /home/henrik/hobbit/release/hobbit-4.2.0/hobbitd/hobbitd_alert.c ./hobbitd/hobbitd_alert.c
--- /home/henrik/hobbit/release/hobbit-4.2.0/hobbitd/hobbitd_alert.c	2006-08-09 22:10:05.000000000 +0200
+++ ./hobbitd/hobbitd_alert.c	2006-10-03 12:55:27.000000000 +0200
@@ -124,6 +124,9 @@
 		curr = curr->next;
 
 		if (tmp->state == A_DEAD) {
+			if (tmp->osname) xfree(tmp->osname);
+			if (tmp->classname) xfree(tmp->classname);
+			if (tmp->groups) xfree(tmp->groups);
 			if (tmp->pagemessage) xfree(tmp->pagemessage);
 			if (tmp->ackmessage) xfree(tmp->ackmessage);
 			xfree(tmp);
@@ -285,7 +288,8 @@
 		}
 
 		if (i > 9) {
-			char *key, *valid = NULL;
+			char *valid = NULL;
+
 			activealerts_t *newalert = (activealerts_t *)calloc(1, sizeof(activealerts_t));
 			newalert->hostname = find_name(hostnames, item[0]);
 			newalert->testname = find_name(testnames, item[1]);
@@ -297,10 +301,13 @@
 			newalert->state = A_PAGING;
 
 			if (statusbuf) {
+				char *key;
+
 				key = (char *)malloc(strlen(newalert->hostname) + strlen(newalert->testname) + 100);
 				sprintf(key, "\n%s|%s|%s\n", newalert->hostname, newalert->testname, colorname(newalert->color));
 				valid = strstr(statusbuf, key);
 				if (!valid && (strncmp(statusbuf, key+1, strlen(key+1)) == 0)) valid = statusbuf;
+				xfree(key);
 			}
 			if (!valid) {
 				errprintf("Stale alert for %s:%s dropped\n", newalert->hostname, newalert->testname);
@@ -648,10 +655,12 @@
 
 			strcpy(awalk->ip, metadata[5]);
 			awalk->cookie = atoi(metadata[11]);
+			if (awalk->osname) xfree(awalk->osname);
 			awalk->osname    = (metadata[12] ? strdup(metadata[12]) : NULL);
+			if (awalk->classname) xfree(awalk->classname);
 			awalk->classname = (metadata[13] ? strdup(metadata[13]) : NULL);
+			if (awalk->groups) xfree(awalk->groups);
 			awalk->groups    = (metadata[14] ? strdup(metadata[14]) : NULL);
-
 			if (awalk->pagemessage) xfree(awalk->pagemessage);
 			awalk->pagemessage = strdup(restofmsg);
 		}
diff -urN /home/henrik/hobbit/release/hobbit-4.2.0/hobbitd/hobbitd_buffer.c ./hobbitd/hobbitd_buffer.c
--- /home/henrik/hobbit/release/hobbit-4.2.0/hobbitd/hobbitd_buffer.c	2006-08-09 22:10:05.000000000 +0200
+++ ./hobbitd/hobbitd_buffer.c	2007-02-09 11:27:54.461530794 +0100
@@ -34,6 +34,7 @@
 		  case C_STACHG: v = getenv("MAXMSG_STACHG"); defvalue = shbufsz(C_STATUS); break;
 		  case C_PAGE:   v = getenv("MAXMSG_PAGE");   defvalue = shbufsz(C_STATUS); break;
 		  case C_ENADIS: v = getenv("MAXMSG_ENADIS"); defvalue =  32; break;
+		  case C_USER:   v = getenv("MAXMSG_USER");   defvalue = 128; break;
 		  default: break;
 		}
 
diff -urN /home/henrik/hobbit/release/hobbit-4.2.0/hobbitd/hobbitd_buffer.h ./hobbitd/hobbitd_buffer.h
--- /home/henrik/hobbit/release/hobbit-4.2.0/hobbitd/hobbitd_buffer.h	2006-08-09 22:10:05.000000000 +0200
+++ ./hobbitd/hobbitd_buffer.h	2007-02-09 11:27:54.469529339 +0100
@@ -11,7 +11,7 @@
 #ifndef __HOBBITD_BUFFER_H__
 #define __HOBBITD_BUFFER_H__
 
-enum msgchannels_t { C_STATUS=1, C_STACHG, C_PAGE, C_DATA, C_NOTES, C_ENADIS, C_CLIENT, C_CLICHG, C_LAST };
+enum msgchannels_t { C_STATUS=1, C_STACHG, C_PAGE, C_DATA, C_NOTES, C_ENADIS, C_CLIENT, C_CLICHG, C_USER, C_LAST };
 
 extern unsigned int shbufsz(enum msgchannels_t chnid);
 #endif
diff -urN /home/henrik/hobbit/release/hobbit-4.2.0/hobbitd/hobbitd_client.c ./hobbitd/hobbitd_client.c
--- /home/henrik/hobbit/release/hobbit-4.2.0/hobbitd/hobbitd_client.c	2006-08-09 22:10:05.000000000 +0200
+++ ./hobbitd/hobbitd_client.c	2006-10-03 13:52:29.000000000 +0200
@@ -896,7 +896,9 @@
 					swalk->sname+5);
 			}
 			addtobuffer(yellowdata, msgline);
+			addtobuffer(yellowdata, "<pre>\n");
 			addtostrbuffer(yellowdata, logsummary);
+			addtobuffer(yellowdata, "</pre>\n");
 			break;
 
 		  case COL_RED:
@@ -909,7 +911,9 @@
 					swalk->sname+5);
 			}
 			addtobuffer(reddata, msgline);
+			addtobuffer(yellowdata, "<pre>\n");
 			addtostrbuffer(reddata, logsummary);
+			addtobuffer(yellowdata, "</pre>\n");
 			break;
 		}
 
@@ -963,7 +967,9 @@
 				swalk->sname+5);
 		}
 		addtostatus(msgline);
+		addtobuffer(yellowdata, "<pre>\n");
 		addtostatus(swalk->sdata);
+		addtobuffer(yellowdata, "</pre>\n");
 		do { swalk=swalk->next; } while (swalk && strncmp(swalk->sname, "msgs:", 5));
 	}
 
@@ -1490,11 +1496,12 @@
 		else if (strcmp(s, "disk") == 0) {
 			unsigned long warnlevel, paniclevel;
 			int abswarn, abspanic, ignored;
+			char *groups;
 
 			printf("Filesystem: "); fflush(stdout);
 			fgets(s, sizeof(s), stdin); clean_instr(s);
 			cfid = get_disk_thresholds(hinfo, clientclass, s, &warnlevel, &paniclevel, 
-						   &abswarn, &abspanic, &ignored, NULL);
+						   &abswarn, &abspanic, &ignored, &groups);
 			if (ignored) 
 				printf("Ignored\n");
 			else
@@ -1506,6 +1513,7 @@
 			int pchecks = clear_process_counts(hinfo, clientclass);
 			char *pname, *pid;
 			int pcount, pmin, pmax, pcolor, ptrack;
+			char *groups;
 			FILE *fd;
 
 			if (pchecks == 0) {
@@ -1530,7 +1538,7 @@
 				}
 			} while (*s);
 
-			while ((pname = check_process_count(&pcount, &pmin, &pmax, &pcolor, &pid, &ptrack, NULL)) != NULL) {
+			while ((pname = check_process_count(&pcount, &pmin, &pmax, &pcolor, &pid, &ptrack, &groups)) != NULL) {
 				printf("Process %s color %s: Count=%d, min=%d, max=%d\n",
 					pname, colorname(pcolor), pcount, pmin, pmax);
 			}
@@ -1576,6 +1584,7 @@
 		else if (strcmp(s, "port") == 0) {
 			char *localstr, *remotestr, *statestr, *p, *pname, *pid;
 			int pcount, pmin, pmax, pcolor, pchecks, ptrack;
+			char *groups;
 			int localcol = 4, remotecol = 5, statecol = 6, portcolor = COL_GREEN;
 
 			pchecks = clear_port_counts(hinfo, clientclass);
@@ -1619,7 +1628,7 @@
 			} while (*s);
 
 			/* Check the number found for each monitored port */
- 			while ((pname = check_port_count(&pcount, &pmin, &pmax, &pcolor, &pid, &ptrack, NULL)) != NULL) {
+ 			while ((pname = check_port_count(&pcount, &pmin, &pmax, &pcolor, &pid, &ptrack, &groups)) != NULL) {
  				char limtxt[1024];
 			
 				if (pmax == -1) {
diff -urN /home/henrik/hobbit/release/hobbit-4.2.0/hobbitd/hobbitd_ipc.c ./hobbitd/hobbitd_ipc.c
--- /home/henrik/hobbit/release/hobbit-4.2.0/hobbitd/hobbitd_ipc.c	2006-08-09 22:10:05.000000000 +0200
+++ ./hobbitd/hobbitd_ipc.c	2007-02-09 11:27:54.477527885 +0100
@@ -49,6 +49,7 @@
 	"enadis",
 	"client",
 	"clichg",
+	"user",
 	NULL
 };
 
diff -urN /home/henrik/hobbit/release/hobbit-4.2.0/hobbitd/hobbitfetch.c ./hobbitd/hobbitfetch.c
--- /home/henrik/hobbit/release/hobbit-4.2.0/hobbitd/hobbitfetch.c	2006-08-09 22:10:05.000000000 +0200
+++ ./hobbitd/hobbitfetch.c	2006-10-03 12:55:27.000000000 +0200
@@ -30,6 +30,7 @@
 #include <stdlib.h>
 #include <string.h>
 #include <stdio.h>
+#include <arpa/nameser.h>
 #include <netdb.h>
 #include <ctype.h>
 #include <signal.h>
@@ -619,14 +620,36 @@
 					ip = strdup(bbh_item(hostwalk, BBH_IP));
 				}
 				else {
+					/* There is an explicit IP setting in the pulldata tag */
 					char *p;
 
 					ip++; /* Skip the '=' */
 					ip = strdup(ip);
 					p = strchr(ip, ':');
 					if (p) { *p = '\0'; port = atoi(p+1); }
+
+					if (*ip == '\0') {
+						/* No IP given, just a port number */
+						xfree(ip);
+						ip = strdup(bbh_item(hostwalk, BBH_IP));
+					}
+				}
+
+				if (strcmp(ip, "0.0.0.0") == 0) {
+					struct hostent *hent;
+
+					xfree(ip); ip = NULL;
+					hent = gethostbyname(clientwalk->hostname);
+					if (hent) {
+						struct in_addr addr;
+
+						memcpy(&addr, *(hent->h_addr_list), sizeof(addr));
+						ip = strdup(inet_ntoa(addr));
+					}
 				}
 
+				if (!ip) continue;
+
 				/* 
 				 * Build the "pullclient" request, which includes the latest
 				 * clientdata config we got from the server. Keep the clientdata
diff -urN /home/henrik/hobbit/release/hobbit-4.2.0/hobbitd/rrd/do_ncv.c ./hobbitd/rrd/do_ncv.c
--- /home/henrik/hobbit/release/hobbit-4.2.0/hobbitd/rrd/do_ncv.c	2006-08-09 22:10:06.000000000 +0200
+++ ./hobbitd/rrd/do_ncv.c	2006-10-03 12:55:27.000000000 +0200
@@ -11,7 +11,7 @@
 /*                                                                            */
 /*----------------------------------------------------------------------------*/
 
-static char ncv_rcsid[] = "$Id: do_ncv.c,v 1.10 2006/06/09 22:23:49 henrik Rel $";
+static char ncv_rcsid[] = "$Id: do_ncv.c,v 1.10 2006/06/09 22:23:49 henrik Rel henrik $";
 
 int do_ncv_rrd(char *hostname, char *testname, char *msg, time_t tstamp) 
 { 
@@ -44,11 +44,22 @@
 
 		l += strspn(l, " \t\n");
 		if (*l) { 
+			/* See if this line contains a '=' or ':' sign */
 			name = l; 
-			l += strcspn(l, ":="); 
-			if( *l ) { *l = '\0'; l++; }
-			else break;
+			l += strcspn(l, ":=\n"); 
+
+			if (*l) {
+				if (( *l == '=') || (*l == ':')) { 
+					*l = '\0'; l++;
+				}
+				else {
+					/* No marker, so skip this line */
+					name = NULL;
+				}
+			}
+			else break;	/* We've hit the end of the message */
 		}
+
 		if (name) { 
 			val = l + strspn(l, " \t"); 
 			l = val + strspn(val, "0123456789."); 
diff -urN /home/henrik/hobbit/release/hobbit-4.2.0/hobbitd/webfiles/confreport_front ./hobbitd/webfiles/confreport_front
--- /home/henrik/hobbit/release/hobbit-4.2.0/hobbitd/webfiles/confreport_front	2006-08-09 22:10:10.000000000 +0200
+++ ./hobbitd/webfiles/confreport_front	2006-10-03 12:55:27.000000000 +0200
@@ -7,7 +7,6 @@
             <tr><th align=left valign=top width="25%">Aliases</th><td>Names for this host other than the primary name, e.g. a hostname used by a client installed on the server</td></tr>
             <tr><th align=left valign=top width="25%">Monitoring location</th><td>The location of this host on the Hobbit webpages</td></tr>
             <tr><th align=left valign=top width="25%">Comment<br>Description</th><td>Explanatory text about the host</td></tr>
-            <tr><th align=left valign=top width="25%">NK monitoring period</th><td>Time of day/week when the NK-enabled alerts will appear on the NK monitor</td></tr>
             <tr><th align=left valign=top width="25%">Planned downtime</th><td>Time of day/week when the host monitoring is disabled</td></tr>
             <tr><th align=left valign=top width="25%">SLA Reporting Period</th><td>Time of day/week where the status impacts the SLA availability calculation</td></tr>
          </table>
@@ -17,7 +16,7 @@
       <td>
          <table width="100%">
             <tr><th align=left valign=top width="25%">Service</th><td>Corresponds to the column-name on the Hobbit webpage</td></tr>
-            <tr><th align=left valign=top width="25%">NK</th><td>Whether this test appears on the NK view</td></tr>
+            <tr><th align=left valign=top width="25%">Critical</th><td>Whether this test appears on the Critical Systems view</td></tr>
             <tr><th align=left valign=top width="25%">C/Y/R limits</th><td>If set, this is the number of failures that must happen before the status changes to Clear/Yellow/Red</td></tr>
             <tr><th align=left valign=top width="25%">Specifics</th><td>Details about how this status is monitored</td></tr>
          </table>
@@ -27,7 +26,7 @@
       <td>
          <table width="100%">
             <tr><th align=left valign=top width="25%">Service</th><td>Corresponds to the column-name on the Hobbit webpage</td></tr>
-            <tr><th align=left valign=top width="25%">NK</th><td>Whether this test appears on the NK view</td></tr>
+            <tr><th align=left valign=top width="25%">Critical</th><td>Whether this test appears on the Critical view</td></tr>
             <tr><th align=left valign=top width="25%">C/Y/R limits</th><td>If set, this is the number of failures that must happen before the status changes to Clear/Yellow/Red</td></tr>
             <tr><th align=left valign=top width="25%">Configuration</th><td>Details about how this status is monitored. NOTE: The exact thresholds for each test are configured on the client, and may differ from that listed here.</td></tr>
          </table>
diff -urN /home/henrik/hobbit/release/hobbit-4.2.0/hobbitd/webfiles/hobbitnk_footer ./hobbitd/webfiles/hobbitnk_footer
--- /home/henrik/hobbit/release/hobbit-4.2.0/hobbitd/webfiles/hobbitnk_footer	2006-08-09 22:10:10.000000000 +0200
+++ ./hobbitd/webfiles/hobbitnk_footer	2006-10-03 12:55:27.000000000 +0200
@@ -17,6 +17,7 @@
        </TD>
        <TD ALIGN=CENTER>
           <SELECT NAME="MINCOLOR">
+	    <OPTION VALUE="purple" &SELECT_MINCOLOR_PURPLE>Red+Yellow+Purple
 	    <OPTION VALUE="yellow" &SELECT_MINCOLOR_YELLOW>Red+Yellow
 	    <OPTION VALUE="red"    &SELECT_MINCOLOR_RED>Red only
 	  </SELECT>
diff -urN /home/henrik/hobbit/release/hobbit-4.2.0/hobbitd/webfiles/info_header ./hobbitd/webfiles/info_header
--- /home/henrik/hobbit/release/hobbit-4.2.0/hobbitd/webfiles/info_header	2006-08-09 22:10:10.000000000 +0200
+++ ./hobbitd/webfiles/info_header	2006-10-03 13:52:29.000000000 +0200
@@ -20,6 +20,15 @@
         else
                 field.checked = val;
 }
+
+function mark4Disable(services) {
+	for(i=0; i<document.disableform.disabletest.length; i++) {
+		if (services.indexOf(',' + document.disableform.disabletest.options[i].value + ',') > -1) {
+			document.disableform.disabletest.options[i].selected = !document.disableform.disabletest.options[i].selected;
+		}
+	}
+}
+
 </script>
 
 <script language="JavaScript1.2" type="text/javascript">
